--- audacious/po/de.po  2011-12-29 18:10:49.042668117 +0100
+++ audacious/po/de.po  2011-12-29 18:15:29.445997193 +0100
@@ -1,9 +1,9 @@
 msgid ""
 msgstr ""
 "Project-Id-Version: Audacious\n"
-"Report-Msgid-Bugs-To: http://jira.atheme.org/\n"
-"POT-Creation-Date: 2011-12-01 17:27+0100\n"
-"PO-Revision-Date: 2011-12-01 17:35+0000\n"
+"Report-Msgid-Bugs-To: http://redmine.audacious-media-player.org/\n"
+"POT-Creation-Date: 2011-12-29 18:14+0100\n"
+"PO-Revision-Date: 2011-12-29 18:15+0000\n"
 "Last-Translator: Thomas Lange\n"
 "Language-Team: German\n"
 "Language: de\n"
@@ -12,18 +12,18 @@
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n != 1)\n"

-#: src/audacious/adder.c:76
+#: src/audacious/adder.c:77
 msgid "Searching ..."
 msgstr "Suche ..."

-#: src/audacious/adder.c:102
+#: src/audacious/adder.c:113
 #, c-format
 msgid "%d file found"
 msgid_plural "%d files found"
 msgstr[0] "%d Datei gefunden"
 msgstr[1] "%d Dateien gefunden"

-#: src/audacious/chardet.c:38
+#: src/audacious/chardet.c:39
 msgid "  (invalid UTF-8)"
 msgstr "  (ungültiges UTF-8)"

@@ -79,139 +79,139 @@
 msgid "Catalan:"
 msgstr "Katalanisch:"

-#: src/audacious/credits.c:201
+#: src/audacious/credits.c:202
 msgid "Chinese:"
 msgstr "Chinesisch:"

-#: src/audacious/credits.c:204
+#: src/audacious/credits.c:205
 msgid "Croatian:"
 msgstr "Kroatisch:"

-#: src/audacious/credits.c:207
+#: src/audacious/credits.c:208
 msgid "Czech:"
 msgstr "Tschechisch:"

-#: src/audacious/credits.c:210
+#: src/audacious/credits.c:211
 msgid "Dutch:"
 msgstr "Niederländisch:"

-#: src/audacious/credits.c:214
+#: src/audacious/credits.c:215
 msgid "Estonian:"
 msgstr "Estnisch:"

-#: src/audacious/credits.c:217
+#: src/audacious/credits.c:218
 msgid "Finnish:"
 msgstr "Finnisch:"

-#: src/audacious/credits.c:222
+#: src/audacious/credits.c:223
 msgid "French:"
 msgstr "Französisch:"

-#: src/audacious/credits.c:228
+#: src/audacious/credits.c:229
 msgid "German:"
 msgstr "Deutsch:"

-#: src/audacious/credits.c:235
+#: src/audacious/credits.c:236
 msgid "Georgian:"
 msgstr "Georgisch:"

-#: src/audacious/credits.c:238
+#: src/audacious/credits.c:239
 msgid "Greek:"
 msgstr "Griechisch:"

-#: src/audacious/credits.c:243
+#: src/audacious/credits.c:244
 msgid "Hindi:"
 msgstr "Hindi:"

-#: src/audacious/credits.c:246
+#: src/audacious/credits.c:247
 msgid "Hungarian:"
 msgstr "Ungarisch:"

-#: src/audacious/credits.c:250
+#: src/audacious/credits.c:251
 msgid "Italian:"
 msgstr "Italienisch:"

-#: src/audacious/credits.c:254
+#: src/audacious/credits.c:256
 msgid "Japanese:"
 msgstr "Japanisch:"

-#: src/audacious/credits.c:257
+#: src/audacious/credits.c:259
 msgid "Korean:"
 msgstr "Koreanisch:"

-#: src/audacious/credits.c:260
+#: src/audacious/credits.c:262
 msgid "Latvian:"
 msgstr "Lettisch:"

-#: src/audacious/credits.c:263
+#: src/audacious/credits.c:265
 msgid "Lithuanian:"
 msgstr "Litauisch:"

-#: src/audacious/credits.c:268
+#: src/audacious/credits.c:270
 msgid "Macedonian:"
 msgstr "Makedonisch:"

-#: src/audacious/credits.c:271
+#: src/audacious/credits.c:273
 msgid "Polish:"
 msgstr "Polnisch:"

-#: src/audacious/credits.c:277
+#: src/audacious/credits.c:279
 msgid "Portuguese:"
 msgstr "Portugiesisch:"

-#: src/audacious/credits.c:280
+#: src/audacious/credits.c:282
 msgid "Romanian:"
 msgstr "Rumänisch:"

-#: src/audacious/credits.c:284
+#: src/audacious/credits.c:286
 msgid "Russian:"
 msgstr "Russisch:"

-#: src/audacious/credits.c:288
+#: src/audacious/credits.c:290
 msgid "Serbian (Latin):"
 msgstr "Serbisch (Latin):"

-#: src/audacious/credits.c:291
+#: src/audacious/credits.c:293
 msgid "Serbian (Cyrillic):"
 msgstr "Serbisch (Kyrillisch):"

-#: src/audacious/credits.c:295
+#: src/audacious/credits.c:297
 msgid "Simplified Chinese:"
 msgstr "Vereinfachtes Chinesisch:"

-#: src/audacious/credits.c:298
+#: src/audacious/credits.c:300
 msgid "Slovak:"
 msgstr "Slovakisch:"

-#: src/audacious/credits.c:301
+#: src/audacious/credits.c:303
 msgid "Spanish:"
 msgstr "Spanisch:"

-#: src/audacious/credits.c:308
+#: src/audacious/credits.c:311
 msgid "Swedish:"
 msgstr "Schwedisch:"

-#: src/audacious/credits.c:311
+#: src/audacious/credits.c:314
 msgid "Traditional Chinese:"
 msgstr "Traditionelles Chinesisch:"

-#: src/audacious/credits.c:317
+#: src/audacious/credits.c:320
 msgid "Turkish:"
 msgstr "Türkisch:"

-#: src/audacious/credits.c:321
+#: src/audacious/credits.c:324
 msgid "Ukrainian:"
 msgstr "Ukrainisch:"

-#: src/audacious/credits.c:325
+#: src/audacious/credits.c:328
 msgid "Vietnamese:"
 msgstr "Vietnamesisch:"

-#: src/audacious/credits.c:328
+#: src/audacious/credits.c:331
 msgid "Welsh:"
 msgstr "Walisisch:"

-#: src/audacious/equalizer_preset.c:187
+#: src/audacious/equalizer_preset.c:180
 #, c-format
 msgid "Error importing Winamp EQF file '%s'"
 msgstr "Fehler beim Import der Winamp-EQF-Datei '%s'"
@@ -285,24 +285,24 @@
 "%s: %s\n"
 "`%s --help' für weitere Informationen versuchen.\n"

-#: src/audacious/main.c:552
+#: src/audacious/main.c:572
 msgid "Audacious"
 msgstr "Audacious"

-#: src/audacious/playback.c:306
+#: src/audacious/playback.c:307
 #, c-format
 msgid "No decoder found for %s."
 msgstr "Kein Decoder gefunden für %s."

-#: src/audacious/playlist-new.c:129
+#: src/audacious/playlist-new.c:131
 msgid "New Playlist"
 msgstr "Neue Wiedergabeliste"

-#: src/audacious/playlist-new.c:130
+#: src/audacious/playlist-new.c:132
 msgid "Now Playing"
 msgstr "Momentane Wiedergabe"

-#: src/audacious/playlist-new.c:1622
+#: src/audacious/playlist-new.c:1624
 msgid ""
 "The playlist cannot be sorted because metadata scanning is still in progress "
 "(or has been disabled)."
@@ -310,274 +310,274 @@
 "Die Wiedergabeliste kann nicht sortiert werden, weil das Scannen der "
 "Metadaten noch aktiv ist (oder deaktiviert wurde)."

-#: src/audacious/ui_preferences.c:88
+#: src/audacious/ui_preferences.c:85
 msgid "Audio"
 msgstr "Audio"

-#: src/audacious/ui_preferences.c:89
+#: src/audacious/ui_preferences.c:86
 msgid "Network"
 msgstr "Netzwerk"

-#: src/audacious/ui_preferences.c:90 src/audacious/ui_preferences.c:1634
+#: src/audacious/ui_preferences.c:87 src/audacious/ui_preferences.c:1603
 msgid "Playlist"
 msgstr ""
 "Wiedergabe-\n"
 "Liste"

-#: src/audacious/ui_preferences.c:91
+#: src/audacious/ui_preferences.c:88
 msgid "Plugins"
 msgstr "Plugins"

-#: src/audacious/ui_preferences.c:97 src/libaudgui/infopopup.c:203
+#: src/audacious/ui_preferences.c:94 src/libaudgui/infopopup.c:203
 msgid "Artist"
 msgstr "Künstler"

-#: src/audacious/ui_preferences.c:98 src/libaudgui/infopopup.c:205
+#: src/audacious/ui_preferences.c:95 src/libaudgui/infopopup.c:205
 msgid "Album"
 msgstr "Album"

-#: src/audacious/ui_preferences.c:99 src/libaudgui/infopopup.c:201
-#: src/libaudgui/ui_playlist_manager.c:276
+#: src/audacious/ui_preferences.c:96 src/libaudgui/infopopup.c:201
+#: src/libaudgui/ui_playlist_manager.c:279
 msgid "Title"
 msgstr "Titel"

-#: src/audacious/ui_preferences.c:100
+#: src/audacious/ui_preferences.c:97
 msgid "Tracknumber"
 msgstr "Titelnummer"

-#: src/audacious/ui_preferences.c:101 src/libaudgui/infopopup.c:207
+#: src/audacious/ui_preferences.c:98 src/libaudgui/infopopup.c:207
 msgid "Genre"
 msgstr "Genre"

-#: src/audacious/ui_preferences.c:102
+#: src/audacious/ui_preferences.c:99
 msgid "Filename"
 msgstr "Dateiname"

-#: src/audacious/ui_preferences.c:103
+#: src/audacious/ui_preferences.c:100
 msgid "Filepath"
 msgstr "Dateipfad"

-#: src/audacious/ui_preferences.c:104
+#: src/audacious/ui_preferences.c:101
 msgid "Date"
 msgstr "Datum"

-#: src/audacious/ui_preferences.c:105 src/libaudgui/infopopup.c:209
+#: src/audacious/ui_preferences.c:102 src/libaudgui/infopopup.c:209
 msgid "Year"
 msgstr "Jahr"

-#: src/audacious/ui_preferences.c:106
+#: src/audacious/ui_preferences.c:103
 msgid "Comment"
 msgstr "Kommentar"

-#: src/audacious/ui_preferences.c:107
+#: src/audacious/ui_preferences.c:104
 msgid "Codec"
 msgstr "Codec"

-#: src/audacious/ui_preferences.c:108
+#: src/audacious/ui_preferences.c:105
 msgid "Quality"
 msgstr "Qualität"

-#: src/audacious/ui_preferences.c:114
+#: src/audacious/ui_preferences.c:111
 msgid "None"
 msgstr "Keine"

-#: src/audacious/ui_preferences.c:115
+#: src/audacious/ui_preferences.c:112
 msgid "Arabic"
 msgstr "Arabisch"

-#: src/audacious/ui_preferences.c:116
+#: src/audacious/ui_preferences.c:113
 msgid "Baltic"
 msgstr "Baltisch"

-#: src/audacious/ui_preferences.c:117
+#: src/audacious/ui_preferences.c:114
 msgid "Chinese"
 msgstr "Chinesisch"

-#: src/audacious/ui_preferences.c:118
+#: src/audacious/ui_preferences.c:115
 msgid "Greek"
 msgstr "Griechisch"

-#: src/audacious/ui_preferences.c:119
+#: src/audacious/ui_preferences.c:116
 msgid "Hebrew"
 msgstr "Hebräisch"

-#: src/audacious/ui_preferences.c:120
+#: src/audacious/ui_preferences.c:117
 msgid "Japanese"
 msgstr "Japanisch"

-#: src/audacious/ui_preferences.c:121
+#: src/audacious/ui_preferences.c:118
 msgid "Korean"
 msgstr "Koreanisch"

-#: src/audacious/ui_preferences.c:122
+#: src/audacious/ui_preferences.c:119
 msgid "Polish"
 msgstr "Polnisch"

-#: src/audacious/ui_preferences.c:123
+#: src/audacious/ui_preferences.c:120
 msgid "Russian"
 msgstr "Russisch"

-#: src/audacious/ui_preferences.c:124
+#: src/audacious/ui_preferences.c:121
 msgid "Taiwanese"
 msgstr "Taiwanisch"

-#: src/audacious/ui_preferences.c:125
+#: src/audacious/ui_preferences.c:122
 msgid "Turkish"
 msgstr "Türkisch"

-#: src/audacious/ui_preferences.c:147
+#: src/audacious/ui_preferences.c:144
 msgid "Album mode"
 msgstr "Album-Modus"

-#: src/audacious/ui_preferences.c:150
+#: src/audacious/ui_preferences.c:147
 msgid "<b>Output Settings</b>"
 msgstr "<b>Ausgabe-Einstellungen</b>"

-#: src/audacious/ui_preferences.c:152
+#: src/audacious/ui_preferences.c:149
 msgid "Bit depth:"
 msgstr "Bit-Tiefe:"

-#: src/audacious/ui_preferences.c:155
+#: src/audacious/ui_preferences.c:152
 msgid "Buffer size:"
 msgstr "Puffergröße:"

-#: src/audacious/ui_preferences.c:157
+#: src/audacious/ui_preferences.c:154
 msgid "ms"
 msgstr "ms"

-#: src/audacious/ui_preferences.c:158
+#: src/audacious/ui_preferences.c:155
 msgid "Use software volume control (not recommended)"
 msgstr "Softwareseitige Lautstärkeregelung benutzen (nicht empfohlen)"

-#: src/audacious/ui_preferences.c:160
+#: src/audacious/ui_preferences.c:157
 msgid "<b>Replay Gain</b>"
 msgstr "<b>Wiedergabe-Verstärkung</b>"

-#: src/audacious/ui_preferences.c:161
+#: src/audacious/ui_preferences.c:158
 msgid "Enable Replay Gain"
 msgstr "Wiedergabe-Verstärkung aktivieren"

-#: src/audacious/ui_preferences.c:164
+#: src/audacious/ui_preferences.c:161
 msgid "Prevent clipping (recommended)"
 msgstr "Übersteuern verhindern (empfohlen)"

-#: src/audacious/ui_preferences.c:166
+#: src/audacious/ui_preferences.c:163
 msgid "<b>Adjust Levels</b>"
 msgstr "<b>Pegel anpassen</b>"

-#: src/audacious/ui_preferences.c:167
+#: src/audacious/ui_preferences.c:164
 msgid "Amplify all files:"
 msgstr "Alle Dateien verstärken:"

-#: src/audacious/ui_preferences.c:169 src/audacious/ui_preferences.c:172
+#: src/audacious/ui_preferences.c:166 src/audacious/ui_preferences.c:169
 msgid "dB"
 msgstr "dB"

-#: src/audacious/ui_preferences.c:170
+#: src/audacious/ui_preferences.c:167
 msgid "Amplify untagged files:"
 msgstr "Unmarkierte Dateien verstärken:"

-#: src/audacious/ui_preferences.c:175
+#: src/audacious/ui_preferences.c:172
 msgid "Proxy hostname:"
 msgstr "Proxy-Host:"

-#: src/audacious/ui_preferences.c:176
+#: src/audacious/ui_preferences.c:173
 msgid "Proxy port:"
 msgstr "Proxy-Port:"

-#: src/audacious/ui_preferences.c:179
+#: src/audacious/ui_preferences.c:176
 msgid "Proxy username:"
 msgstr "Benutzername für Proxy:"

-#: src/audacious/ui_preferences.c:180
+#: src/audacious/ui_preferences.c:177
 msgid "Proxy password:"
 msgstr "Passwort für Proxy:"

-#: src/audacious/ui_preferences.c:184
+#: src/audacious/ui_preferences.c:181
 msgid "<b>Proxy Configuration</b>"
 msgstr "<b>Proxy-Konfiguration</b>"

-#: src/audacious/ui_preferences.c:185
+#: src/audacious/ui_preferences.c:182
 msgid "Enable proxy usage"
 msgstr "Proxy aktivieren"

-#: src/audacious/ui_preferences.c:188
+#: src/audacious/ui_preferences.c:185
 msgid "Use authentication with proxy"
 msgstr "Benutze Authentisierung mit Proxy"

-#: src/audacious/ui_preferences.c:196
+#: src/audacious/ui_preferences.c:193
 msgid "Auto character encoding detector for:"
 msgstr "Automatische Zeichensatzerkennung für:"

-#: src/audacious/ui_preferences.c:201
+#: src/audacious/ui_preferences.c:198
 msgid "Fallback character encodings:"
 msgstr "Alternative Zeichensätze:"

-#: src/audacious/ui_preferences.c:205
+#: src/audacious/ui_preferences.c:202
 msgid "<b>Behavior</b>"
 msgstr "<b>Verhalten</b>"

-#: src/audacious/ui_preferences.c:206
+#: src/audacious/ui_preferences.c:203
 msgid "Continue playback on startup"
 msgstr "Wiedergabe beim Starten fortführen"

-#: src/audacious/ui_preferences.c:208
+#: src/audacious/ui_preferences.c:205
 msgid "Advance when the current song is deleted"
 msgstr "Fortschreiten falls aktueller Titel gelöscht wird"

-#: src/audacious/ui_preferences.c:210
+#: src/audacious/ui_preferences.c:207
 msgid "Clear the playlist when opening files"
 msgstr "Wiedergabeliste beim Öffnen neuer Dateien leeren"

-#: src/audacious/ui_preferences.c:212
+#: src/audacious/ui_preferences.c:209
 msgid "Open files in a temporary playlist"
 msgstr "Dateien in temporärer Wiedergabeliste öffnen"

-#: src/audacious/ui_preferences.c:214
+#: src/audacious/ui_preferences.c:211
 msgid "<b>Metadata</b>"
 msgstr "<b>Metadaten</b>"

-#: src/audacious/ui_preferences.c:215
+#: src/audacious/ui_preferences.c:212
 msgid "Do not load metadata for songs until played"
 msgstr "Metadaten erst laden, wenn Titel gespielt wird"

-#: src/audacious/ui_preferences.c:233
+#: src/audacious/ui_preferences.c:230
 msgid "TITLE"
 msgstr "TITEL"

-#: src/audacious/ui_preferences.c:234
+#: src/audacious/ui_preferences.c:231
 msgid "ARTIST - TITLE"
 msgstr "KÜNSTLER - TITEL"

-#: src/audacious/ui_preferences.c:235
+#: src/audacious/ui_preferences.c:232
 msgid "ARTIST - ALBUM - TITLE"
 msgstr "KÜNSTLER - ALBUM - TITEL"

-#: src/audacious/ui_preferences.c:236
+#: src/audacious/ui_preferences.c:233
 msgid "ARTIST - ALBUM - TRACK. TITLE"
 msgstr "KÜNSTLER - ALBUM - TITELNUMMER. TITEL"

-#: src/audacious/ui_preferences.c:237
+#: src/audacious/ui_preferences.c:234
 msgid "ARTIST [ ALBUM ] - TRACK. TITLE"
 msgstr "KÜNSTLER [ ALBUM ] - TITELNUMMER. TITEL"

-#: src/audacious/ui_preferences.c:238
+#: src/audacious/ui_preferences.c:235
 msgid "ALBUM - TITLE"
 msgstr "ALBUM - TITEL"

-#: src/audacious/ui_preferences.c:577
+#: src/audacious/ui_preferences.c:556
 msgid "Category"
 msgstr "Kategorie"

-#: src/audacious/ui_preferences.c:801
+#: src/audacious/ui_preferences.c:780
 msgid "Popup Information Settings"
 msgstr "Popup-Informations-Einstellungen"

-#: src/audacious/ui_preferences.c:810
+#: src/audacious/ui_preferences.c:789
 msgid "<b>Cover image retrieve</b>"
 msgstr "<b>Cover-Bild finden</b>"

-#: src/audacious/ui_preferences.c:815
+#: src/audacious/ui_preferences.c:794
 msgid ""
 "While searching for the album's cover, Audacious looks for certain words in "
 "the filename. You can specify those words in the lists below, separated "
@@ -587,75 +587,75 @@
 "Dateinamen. Diese können nachfolgend eingegeben werden, jeweils durch Kommas "
 "getrennt."

-#: src/audacious/ui_preferences.c:832
+#: src/audacious/ui_preferences.c:811
 msgid "Exclude:"
 msgstr "Ausschließen:"

-#: src/audacious/ui_preferences.c:839
+#: src/audacious/ui_preferences.c:818
 msgid "Include:"
 msgstr "Einschließen:"

-#: src/audacious/ui_preferences.c:856
+#: src/audacious/ui_preferences.c:835
 msgid "Recursively search for cover"
 msgstr "Rekursiv nach dem Titelbild suchen"

-#: src/audacious/ui_preferences.c:866
+#: src/audacious/ui_preferences.c:845
 msgid "Search depth: "
 msgstr "Suchtiefe: "

-#: src/audacious/ui_preferences.c:880
+#: src/audacious/ui_preferences.c:859
 msgid "Use per-file cover"
 msgstr "Pro-Datei-Titelbild benutzen"

-#: src/audacious/ui_preferences.c:883
+#: src/audacious/ui_preferences.c:862
 msgid "<b>Miscellaneous</b>"
 msgstr "<b>Verschiedenes</b>"

-#: src/audacious/ui_preferences.c:892
+#: src/audacious/ui_preferences.c:871
 msgid "Show Progress bar for the current track"
 msgstr "Zeige Fortschrittsbalken für den aktuellen Titel"

-#: src/audacious/ui_preferences.c:902
+#: src/audacious/ui_preferences.c:881
 msgid "Delay until filepopup comes up: "
 msgstr "Verzögerung bis zum Erscheinen des Popups: "

-#: src/audacious/ui_preferences.c:1340
+#: src/audacious/ui_preferences.c:1309
 msgid "Custom"
 msgstr "Eigene Zeichenkette"

-#: src/audacious/ui_preferences.c:1383
+#: src/audacious/ui_preferences.c:1352
 msgid "<b>Song Display</b>"
 msgstr "<b>Titelanzeige</b>"

-#: src/audacious/ui_preferences.c:1392
+#: src/audacious/ui_preferences.c:1361
 msgid "Show song numbers"
 msgstr "Zeige Titelnummern"

-#: src/audacious/ui_preferences.c:1403
+#: src/audacious/ui_preferences.c:1372
 msgid "Show leading zeroes (02:00 instead of 2:00)"
 msgstr "Führende Nullen anzeigen (02:00 anstatt 2:00)"

-#: src/audacious/ui_preferences.c:1425
+#: src/audacious/ui_preferences.c:1394
 msgid "Show information about titlestring format"
 msgstr "Informationen über das Format der Titelzeile anzeigen"

-#: src/audacious/ui_preferences.c:1441
+#: src/audacious/ui_preferences.c:1410
 msgid "Custom string:"
 msgstr "Eigene Zeichenkette:"

-#: src/audacious/ui_preferences.c:1448
+#: src/audacious/ui_preferences.c:1417
 msgid "Title format:"
 msgstr "Titelformat:"

-#: src/audacious/ui_preferences.c:1459
+#: src/audacious/ui_preferences.c:1428
 msgid "<b>Popup Information</b>"
 msgstr "<b>Popup-Information</b>"

-#: src/audacious/ui_preferences.c:1474
+#: src/audacious/ui_preferences.c:1443
 msgid "Show popup information for playlist entries"
 msgstr "Popup-Informationen für Widergabelisteneinträge anzeigen"

-#: src/audacious/ui_preferences.c:1475
+#: src/audacious/ui_preferences.c:1444
 msgid ""
 "Toggles popup information window for the pointed entry in the playlist. The "
 "window shows title of song, name of album, genre, year of publish, track "
@@ -666,35 +666,35 @@
 "werden Titel, Album, Genre, Publikationsjahr, Titelnummer, Titellänge und "
 "Cover-Bild."

-#: src/audacious/ui_preferences.c:1486
+#: src/audacious/ui_preferences.c:1455
 msgid "Edit settings for popup information"
 msgstr "Einstellungen für Popup-Informationen bearbeiten"

-#: src/audacious/ui_preferences.c:1575
+#: src/audacious/ui_preferences.c:1544
 msgid "Output plugin:"
 msgstr "Ausgabe-Plugin:"

-#: src/audacious/ui_preferences.c:1634
+#: src/audacious/ui_preferences.c:1603
 msgid "Transport"
 msgstr "Transport"

-#: src/audacious/ui_preferences.c:1634
+#: src/audacious/ui_preferences.c:1603
 msgid "Input"
 msgstr "Eingabe"

-#: src/audacious/ui_preferences.c:1635
+#: src/audacious/ui_preferences.c:1604
 msgid "Effect"
 msgstr "Effekte"

-#: src/audacious/ui_preferences.c:1635
+#: src/audacious/ui_preferences.c:1604
 msgid "Visualization"
 msgstr "Visualisierung"

-#: src/audacious/ui_preferences.c:1635
+#: src/audacious/ui_preferences.c:1604
 msgid "General"
 msgstr "Allgemein"

-#: src/audacious/ui_preferences.c:1675
+#: src/audacious/ui_preferences.c:1644
 msgid "Audacious Preferences"
 msgstr "Audacious-Einstellungen"

@@ -711,15 +711,20 @@
 msgid "No song playing."
 msgstr "Kein Titel wird wiedergegeben."

-#: src/libaudcore/tuple.c:434
+#: src/libaudcore/audstrings.c:194
+#, c-format
+msgid "Audio CD, track %s"
+msgstr ""
+
+#: src/libaudcore/tuple.c:536
 msgid "Mono"
 msgstr "Mono"

-#: src/libaudcore/tuple.c:436
+#: src/libaudcore/tuple.c:538
 msgid "Stereo"
 msgstr "Stereo"

-#: src/libaudcore/tuple.c:438
+#: src/libaudcore/tuple.c:540
 #, c-format
 msgid "%d channel"
 msgid_plural "%d channels"
@@ -747,55 +752,55 @@
 msgid "settings ..."
 msgstr "Einstellungen ..."

-#: src/libaudgui/equalizer.c:52
+#: src/libaudgui/equalizer.c:53
 msgid "_Enable"
 msgstr "_Aktiv"

-#: src/libaudgui/equalizer.c:124
+#: src/libaudgui/equalizer.c:125
 msgid "31 Hz"
 msgstr "31 Hz"

-#: src/libaudgui/equalizer.c:124
+#: src/libaudgui/equalizer.c:125
 msgid "63 Hz"
 msgstr "63 Hz"

-#: src/libaudgui/equalizer.c:125
+#: src/libaudgui/equalizer.c:126
 msgid "125 Hz"
 msgstr "125 Hz"

-#: src/libaudgui/equalizer.c:125
+#: src/libaudgui/equalizer.c:126
 msgid "250 Hz"
 msgstr "250 Hz"

-#: src/libaudgui/equalizer.c:125
+#: src/libaudgui/equalizer.c:126
 msgid "500 Hz"
 msgstr "500 Hz"

-#: src/libaudgui/equalizer.c:125
+#: src/libaudgui/equalizer.c:126
 msgid "1 kHz"
 msgstr "1 kHz"

-#: src/libaudgui/equalizer.c:125
+#: src/libaudgui/equalizer.c:126
 msgid "2 kHz"
 msgstr "2 kHz"

-#: src/libaudgui/equalizer.c:126
+#: src/libaudgui/equalizer.c:127
 msgid "4 kHz"
 msgstr "4 kHz"

-#: src/libaudgui/equalizer.c:126
+#: src/libaudgui/equalizer.c:127
 msgid "8 kHz"
 msgstr "8 kHz"

-#: src/libaudgui/equalizer.c:126
+#: src/libaudgui/equalizer.c:127
 msgid "16 kHz"
 msgstr "16 kHz"

-#: src/libaudgui/equalizer.c:131
+#: src/libaudgui/equalizer.c:132
 msgid "Equalizer"
 msgstr "Equalizer"

-#: src/libaudgui/equalizer.c:147
+#: src/libaudgui/equalizer.c:148
 msgid "Preamp"
 msgstr "Vorverstärkung"

@@ -1051,7 +1056,7 @@
 msgid "Overwrite %s?"
 msgstr "'%s' überschreiben?"

-#: src/libaudgui/queue-manager.c:185
+#: src/libaudgui/queue-manager.c:198
 msgid "Queue Manager"
 msgstr "Warteschlangen-Manager"

@@ -1067,68 +1072,68 @@
 msgid "Translators"
 msgstr "Übersetzer"

-#: src/libaudgui/ui_fileopener.c:109
+#: src/libaudgui/ui_fileopener.c:108
 msgid "Open Files"
 msgstr "Dateien öffnen"

-#: src/libaudgui/ui_fileopener.c:109
+#: src/libaudgui/ui_fileopener.c:108
 msgid "Add Files"
 msgstr "Dateien hinzufügen"

-#: src/libaudgui/ui_fileopener.c:111
+#: src/libaudgui/ui_fileopener.c:110
 msgid "Close dialog on Open"
 msgstr "Dialog beim Öffnen schließen"

-#: src/libaudgui/ui_fileopener.c:111
+#: src/libaudgui/ui_fileopener.c:110
 msgid "Close dialog on Add"
 msgstr "Dialog beim Hinzufügen schließen"

-#: src/libaudgui/ui_jumptotrack.c:103 src/libaudgui/ui_jumptotrack.c:111
-#: src/libaudgui/ui_jumptotrack.c:322
+#: src/libaudgui/ui_jumptotrack.c:112 src/libaudgui/ui_jumptotrack.c:120
+#: src/libaudgui/ui_jumptotrack.c:329
 msgid "_Queue"
 msgstr "In _Warteschlange"

-#: src/libaudgui/ui_jumptotrack.c:109
+#: src/libaudgui/ui_jumptotrack.c:118
 msgid "Un_queue"
 msgstr "Aus _Warteschlange"

-#: src/libaudgui/ui_jumptotrack.c:239
-msgid "Jump to Track"
+#: src/libaudgui/ui_jumptotrack.c:261
+msgid "Jump to Song"
 msgstr "Zu Titel springen"

-#: src/libaudgui/ui_jumptotrack.c:277
+#: src/libaudgui/ui_jumptotrack.c:284
 msgid "Filter: "
 msgstr "Filter: "

-#: src/libaudgui/ui_jumptotrack.c:278
+#: src/libaudgui/ui_jumptotrack.c:285
 msgid "_Filter:"
 msgstr "_Filter:"

-#: src/libaudgui/ui_jumptotrack.c:288
+#: src/libaudgui/ui_jumptotrack.c:295
 msgid "Remember"
 msgstr "Merken"

-#: src/libaudgui/ui_jumptotrack.c:295
+#: src/libaudgui/ui_jumptotrack.c:302
 msgid "Clea_r"
 msgstr "A-B löschen"

-#: src/libaudgui/ui_jumptotrack.c:315
+#: src/libaudgui/ui_jumptotrack.c:322
 msgid "Close on Jump"
 msgstr "Nach Öffnen schließen"

-#: src/libaudgui/ui_playlist_manager.c:250
+#: src/libaudgui/ui_playlist_manager.c:253
 msgid "Playlist Manager"
 msgstr "Wiedergabelistenverwaltung"

-#: src/libaudgui/ui_playlist_manager.c:277
+#: src/libaudgui/ui_playlist_manager.c:280
 msgid "Entries"
 msgstr "Einträge"

-#: src/libaudgui/ui_playlist_manager.c:298
+#: src/libaudgui/ui_playlist_manager.c:301
 msgid "_Rename"
 msgstr "_Umbenennen"

-#: src/libaudgui/ui_playlist_manager.c:322
+#: src/libaudgui/ui_playlist_manager.c:325
 msgid "_Close dialog on activating playlist"
 msgstr "Dialog beim Öffnen einer Liste _schließen"

@@ -1140,7 +1145,7 @@
 msgid "Add URL"
 msgstr "URL hinzufügen"

-#: src/libaudgui/util.c:95
+#: src/libaudgui/util.c:97
 msgid ""
 "\n"
 "(Further messages have been hidden.)"
@@ -1152,30 +1157,30 @@
 msgid "File is not a valid .desktop file"
 msgstr "Datei ist keine gültige .desktop-Datei"

-#: src/libeggsmclient/eggdesktopfile.c:188
+#: src/libeggsmclient/eggdesktopfile.c:191
 #, c-format
 msgid "Unrecognized desktop file Version '%s'"
 msgstr "Unbekannte Desktop-Datei-Version '%s'"

-#: src/libeggsmclient/eggdesktopfile.c:967
+#: src/libeggsmclient/eggdesktopfile.c:974
 #, c-format
 msgid "Starting %s"
 msgstr "Starte %s"

-#: src/libeggsmclient/eggdesktopfile.c:1108
+#: src/libeggsmclient/eggdesktopfile.c:1116
 msgid "Application does not accept documents on command line"
 msgstr "Programm akzeptiert keine Dokumente auf der Kommandozeile"

-#: src/libeggsmclient/eggdesktopfile.c:1176
+#: src/libeggsmclient/eggdesktopfile.c:1184
 #, c-format
 msgid "Unrecognized launch option: %d"
 msgstr "Unbekannte Start-Option: %d"

-#: src/libeggsmclient/eggdesktopfile.c:1375
+#: src/libeggsmclient/eggdesktopfile.c:1391
 msgid "Can't pass document URIs to a 'Type=Link' desktop entry"
 msgstr "Kann keine Dokument-URIs an einen 'Type=Link'-Desktopeintrag übergeben"

-#: src/libeggsmclient/eggdesktopfile.c:1396
+#: src/libeggsmclient/eggdesktopfile.c:1412
 msgid "Not a launchable item"
 msgstr "Ist nicht ausführbar"