--- audacious-3.3-beta1/po/zh_CN.po.orig	2012-07-05 05:22:13.000000000 +0800
+++ audacious-3.3-beta1/po/zh_CN.po	2012-07-05 16:07:11.895184934 +0800
@@ -8,8 +8,8 @@
 msgstr ""
 "Project-Id-Version: Audacious\n"
 "Report-Msgid-Bugs-To: http://redmine.audacious-media-player.org/\n"
-"POT-Creation-Date: 2012-07-01 14:46-0400\n"
-"PO-Revision-Date: 2011-10-16 19:20+0800\n"
+"POT-Creation-Date: 2012-07-01 15:00-0400\n"
+"PO-Revision-Date: 2012-07-05 16:06+0800\n"
 "Last-Translator: Chasye <chasye@gmail.com>\n"
 "Language-Team: Chinese (simplified)\n"
 "Language: zh_CN\n"
@@ -113,46 +113,44 @@
 #: src/audacious/playback.c:305
 #, c-format
 msgid "No decoder found for %s."
-msgstr "未能为 %s 找到解码器"
+msgstr "未能为 %s 找到解码器。"
 
 #: src/audacious/playlist-files.c:51
 #, c-format
 msgid "Cannot %s %s: unsupported file extension."
-msgstr ""
+msgstr "无法 %s %s: 未支持文件后缀。"
 
 #: src/audacious/playlist-files.c:52
 msgid "save"
-msgstr ""
+msgstr "保存"
 
 #: src/audacious/playlist-files.c:52
 msgid "load"
-msgstr ""
+msgstr "加载"
 
 #: src/audacious/playlist-new.c:121
-#, fuzzy
 msgid "New Playlist"
-msgstr "播放列表"
+msgstr "新建播放列表"
 
 #: src/audacious/playlist-new.c:122
-#, fuzzy
 msgid "Now Playing"
-msgstr "暂未播放"
+msgstr "正在播放"
 
 #: src/audacious/playlist-new.c:1646
 msgid ""
 "The playlist cannot be sorted because metadata scanning is still in progress "
 "(or has been disabled)."
-msgstr ""
+msgstr "因正在扫描歌曲信息, 播放列表暂时无法保存."
 
 #: src/audacious/plugin-preferences.c:50
-#, fuzzy, c-format
+#, c-format
 msgid "About %s"
-msgstr "关于Audacious"
+msgstr "关于 %s"
 
 #: src/audacious/plugin-preferences.c:88
-#, fuzzy, c-format
+#, c-format
 msgid "%s Settings"
-msgstr "设置..."
+msgstr "%s 设置"
 
 #: src/audacious/ui_preferences.c:69
 msgid "Audio"
@@ -168,7 +166,7 @@
 
 #: src/audacious/ui_preferences.c:72
 msgid "Song Info"
-msgstr ""
+msgstr "歌曲信息"
 
 #: src/audacious/ui_preferences.c:73
 msgid "Plugins"
@@ -289,7 +287,7 @@
 
 #: src/audacious/ui_preferences.c:140
 msgid "ms"
-msgstr ""
+msgstr "毫秒"
 
 #: src/audacious/ui_preferences.c:141
 msgid "Use software volume control (not recommended)"
@@ -388,28 +386,26 @@
 msgstr "未播放时切勿加载元数据"
 
 #: src/audacious/ui_preferences.c:205
-#, fuzzy
 msgid "<b>Album Art</b>"
-msgstr "<b>音量控制</b>"
+msgstr "<b>专辑封面</b>"
 
 #: src/audacious/ui_preferences.c:206
 msgid "Search for images matching these words (comma-separated):"
-msgstr ""
+msgstr "搜索匹配以下词语的图片(用逗号分隔)："
 
 #: src/audacious/ui_preferences.c:208
 msgid "Exclude images matching these words (comma-separated):"
-msgstr ""
+msgstr "排除匹配以下词语的图片(用逗号分隔)："
 
 #: src/audacious/ui_preferences.c:210
 msgid "Search for images matching song file name"
-msgstr ""
+msgstr "搜索匹配歌曲文件名的图片"
 
 #: src/audacious/ui_preferences.c:212
 msgid "Search recursively"
-msgstr ""
+msgstr "递归搜索"
 
 #: src/audacious/ui_preferences.c:214
-#, fuzzy
 msgid "Search depth:"
 msgstr "搜索深度："
 
@@ -418,16 +414,14 @@
 msgstr "<b>弹出信息</b>"
 
 #: src/audacious/ui_preferences.c:218
-#, fuzzy
 msgid "Show popup information"
-msgstr "为播放列表显示弹出信息"
+msgstr "显示弹出信息"
 
 #: src/audacious/ui_preferences.c:220
 msgid "Popup delay (tenths of a second):"
-msgstr ""
+msgstr "弹出延迟 (十分之一秒):"
 
 #: src/audacious/ui_preferences.c:223
-#, fuzzy
 msgid "Show time scale for current song"
 msgstr "停止播放"
 
@@ -531,7 +525,7 @@
 #: src/libaudcore/audstrings.c:199
 #, c-format
 msgid "Audio CD, track %s"
-msgstr ""
+msgstr "音频CD, 音轨 %s"
 
 #: src/libaudcore/tuple.c:541
 msgid "Mono"
@@ -631,14 +625,12 @@
 msgstr "前置放大器"
 
 #: src/libaudgui/infopopup.c:202
-#, fuzzy
 msgid "Track"
-msgstr "音轨序号"
+msgstr "音轨"
 
 #: src/libaudgui/infopopup.c:204
-#, fuzzy
 msgid "Length"
-msgstr "音轨长度"
+msgstr "长度"
 
 #: src/libaudgui/infowin.c:74
 msgid "Acid Jazz"
@@ -869,7 +861,7 @@
 
 #: src/libaudgui/jump-to-time.c:61
 msgid "Enter time (minutes:seconds):"
-msgstr ""
+msgstr "输入时间 (分:秒):"
 
 #: src/libaudgui/playlists.c:33
 msgid "Export Playlist"
@@ -914,9 +906,8 @@
 msgstr "出列(_q)"
 
 #: src/libaudgui/ui_jumptotrack.c:262
-#, fuzzy
 msgid "Jump to Song"
-msgstr "跳到时间"
+msgstr "跳到歌曲"
 
 #: src/libaudgui/ui_jumptotrack.c:287
 msgid "Filter: "
@@ -964,7 +955,7 @@
 
 #: src/libaudgui/url-opener.c:65
 msgid "Enter URL:"
-msgstr ""
+msgstr "输入地址"
 
 #: src/libaudgui/util.c:143
 msgid ""
@@ -974,6 +965,153 @@
 "\n"
 "（详细信息已隐藏。）"
 
+#~ msgid "Core developers:"
+#~ msgstr "核心开发者："
+
+#~ msgid "Graphics:"
+#~ msgstr "美工："
+
+#~ msgid "Default skin:"
+#~ msgstr "默认主题："
+
+#~ msgid "Plugin development:"
+#~ msgstr "插件开发："
+
+#~ msgid "Patch authors:"
+#~ msgstr "补丁提交者："
+
+#~ msgid "1.x developers:"
+#~ msgstr "1.x 开发者："
+
+#~ msgid "BMP Developers:"
+#~ msgstr "BMP 开发者："
+
+#~ msgid "Argentinian Spanish:"
+#~ msgstr "阿根廷西班牙语："
+
+#~ msgid "Belarusian:"
+#~ msgstr "匈牙利语："
+
+#~ msgid "Basque:"
+#~ msgstr "巴斯克语："
+
+#~ msgid "Brazilian Portuguese:"
+#~ msgstr "巴西葡萄牙语："
+
+#~ msgid "Breton:"
+#~ msgstr "布列塔尼语："
+
+#~ msgid "Bulgarian:"
+#~ msgstr "匈牙利语："
+
+#~ msgid "Catalan:"
+#~ msgstr "加泰罗尼亚语："
+
+#~ msgid "Chinese:"
+#~ msgstr "汉语："
+
+#~ msgid "Croatian:"
+#~ msgstr "罗马尼亚语："
+
+#~ msgid "Czech:"
+#~ msgstr "捷克语："
+
+#~ msgid "Dutch:"
+#~ msgstr "荷兰语："
+
+#~ msgid "Estonian:"
+#~ msgstr "爱沙尼亚语："
+
+#~ msgid "Finnish:"
+#~ msgstr "芬兰语："
+
+#~ msgid "French:"
+#~ msgstr "法语："
+
+#~ msgid "German:"
+#~ msgstr "德语："
+
+#~ msgid "Georgian:"
+#~ msgstr "乔治亚语："
+
+#~ msgid "Greek:"
+#~ msgstr "希腊语："
+
+#~ msgid "Hindi:"
+#~ msgstr "印地语："
+
+#~ msgid "Hungarian:"
+#~ msgstr "匈牙利语："
+
+#~ msgid "Italian:"
+#~ msgstr "意大利语："
+
+#~ msgid "Japanese:"
+#~ msgstr "日语："
+
+#~ msgid "Korean:"
+#~ msgstr "韩语："
+
+#~ msgid "Latvian:"
+#~ msgstr "拉脱维亚语："
+
+#~ msgid "Lithuanian:"
+#~ msgstr "立陶宛语："
+
+#~ msgid "Macedonian:"
+#~ msgstr "马其顿语："
+
+#~ msgid "Mexican Spanish:"
+#~ msgstr "墨西哥西班牙语："
+
+#~ msgid "Polish:"
+#~ msgstr "波兰语："
+
+#~ msgid "Portuguese:"
+#~ msgstr "葡萄牙语："
+
+#~ msgid "Romanian:"
+#~ msgstr "罗马尼亚语："
+
+#~ msgid "Russian:"
+#~ msgstr "俄语："
+
+#~ msgid "Serbian (Latin):"
+#~ msgstr "塞尔维亚语(拉丁文)："
+
+#~ msgid "Serbian (Cyrillic):"
+#~ msgstr "塞尔维亚语(斯拉夫文)："
+
+#~ msgid "Simplified Chinese:"
+#~ msgstr "简体中文："
+
+#~ msgid "Slovak:"
+#~ msgstr "斯洛伐克语："
+
+#~ msgid "Spanish:"
+#~ msgstr "西班牙语："
+
+#~ msgid "Swedish:"
+#~ msgstr "瑞典语："
+
+#~ msgid "Traditional Chinese:"
+#~ msgstr "繁体中文："
+
+#~ msgid "Turkish:"
+#~ msgstr "土耳其语："
+
+#~ msgid "Ukrainian:"
+#~ msgstr "乌克兰语："
+
+#~ msgid "Vietnamese:"
+#~ msgstr "越南语："
+
+#~ msgid "Welsh:"
+#~ msgstr "威尔斯语："
+
+#~ msgid "Translators"
+#~ msgstr "翻译人员"
+
 #~ msgid "File is not a valid .desktop file"
 #~ msgstr "非合法的.desktop文件"
 
@@ -1015,3 +1153,129 @@
 
 #~ msgid "Show session management options"
 #~ msgstr "显示会话管理器选项"
+
+#~ msgid "Temporary Playlist"
+#~ msgstr "临时播放列表"
+
+#~ msgid "Buffering ..."
+#~ msgstr "缓冲中..."
+
+#~ msgid "Untitled Playlist"
+#~ msgstr "新播放列表"
+
+#~ msgid "Popup Information Settings"
+#~ msgstr "弹出信息设置"
+
+#~ msgid "<b>Cover image retrieve</b>"
+#~ msgstr "<b>专辑封面检索</b>"
+
+#~ msgid ""
+#~ "While searching for the album's cover, Audacious looks for certain words "
+#~ "in the filename. You can specify those words in the lists below, "
+#~ "separated using commas."
+#~ msgstr ""
+#~ "当搜索专辑封面时，Audacious从文件名中找出关键字。您可以在下面列表中指定它"
+#~ "们，用逗号分隔。"
+
+#~ msgid "Exclude:"
+#~ msgstr "排除："
+
+#~ msgid "Include:"
+#~ msgstr "包含："
+
+#~ msgid "Recursively search for cover"
+#~ msgstr "递归搜索封面"
+
+#~ msgid "Use per-file cover"
+#~ msgstr "为每个文件使用单独封面"
+
+#~ msgid "<b>Miscellaneous</b>"
+#~ msgstr "<b>杂项</b>"
+
+#~ msgid "Show Progress bar for the current track"
+#~ msgstr "显示当前音轨的进度"
+
+#~ msgid "Delay until filepopup comes up: "
+#~ msgstr "延迟到文件弹出窗口出现："
+
+#~ msgid ""
+#~ "Toggles popup information window for the pointed entry in the playlist. "
+#~ "The window shows title of song, name of album, genre, year of publish, "
+#~ "track number, track length, and artwork."
+#~ msgstr ""
+#~ "切换播放列表中指向项目的弹出信息窗口。该窗口显示歌曲标题、专辑、流派、年"
+#~ "份，音轨编号，长度和插图等。"
+
+#~ msgid "Edit settings for popup information"
+#~ msgstr "修改弹出信息的设置"
+
+#~ msgid "Track Number"
+#~ msgstr "音轨序号"
+
+#~ msgid "Jump to Track"
+#~ msgstr "跳到"
+
+#~ msgid ""
+#~ "Audacious seems to be already running but is not responding.  You can "
+#~ "start another instance of the program, but please be warned that this can "
+#~ "cause data loss.  If Audacious is not running, you can safely ignore this "
+#~ "message.  Press OK to start Audacious or Cancel to quit."
+#~ msgstr ""
+#~ "Audacious似乎已经启动，但未能作出响应。你可以启动多一个进程，但可能会因此"
+#~ "引起数据丢失。如果Audacious未启动，你完全可以忽略此信息。要启动Audacious点"
+#~ "击\"确定\"，否则点击\"取消\""
+
+#~ msgid "Universal"
+#~ msgstr "世界语"
+
+#~ msgid "Single track mode"
+#~ msgstr "单音轨模式"
+
+#~ msgid ""
+#~ "<span size=\"small\">Changing these settings will require a restart of "
+#~ "Audacious.</span>"
+#~ msgstr "<span size=\"small\">此设置将在Audacious重启后生效</span>"
+
+#~ msgid ""
+#~ "List of character encodings used for fall back conversion of metadata. If "
+#~ "automatic character encoding detector failed or has been disabled, "
+#~ "encodings in this list would be treated as candidates of the encoding of "
+#~ "metadata, and fall back conversion from these encodings to UTF-8 would be "
+#~ "attempted."
+#~ msgstr ""
+#~ "字符编码列表将用于元数据的后备转换。如果自动编码转换检测器失败或被禁用，列"
+#~ "表中的编码将作为元数据的候选编码，并将试图由此转换到UTF-8。"
+
+#~ msgid "Replay Gain"
+#~ msgstr "回放增益"
+
+#~ msgid "<b>Bit Depth</b>"
+#~ msgstr "<b>位深</b>"
+
+#~ msgid ""
+#~ "All streams will be converted to this bit depth.\n"
+#~ "This should be the max supported bit depth of\n"
+#~ "the sound card or output plugin."
+#~ msgstr ""
+#~ "所有音频流将会转换到此位深。\n"
+#~ "此值不应大于您的声卡或输出插件所支持的最大值。"
+
+#~ msgid ""
+#~ "Use software volume control. This may be useful for situations where your "
+#~ "audio system does not support controlling the playback volume."
+#~ msgstr "使用软音量控制。当你无法调整系统音量时可以启用此设置。"
+
+#~ msgid "<b>Mode</b>"
+#~ msgstr "<b>模式</b>"
+
+#~ msgid "<b>Clipping Prevention</b>"
+#~ msgstr "<b>避免爆音</b>"
+
+#~ msgid "Enable clipping prevention"
+#~ msgstr "启用避免爆音"
+
+#~ msgid "<b>Audio System</b>"
+#~ msgstr "<b>音频系统</b>"
+
+#~ msgid "Display all open Audacious windows"
+#~ msgstr "显示所有已打开的Audacious窗口"